/*globals define*/

define([
    'testsuite/qunit',
    'jquery',
    'ep',
    'de_epages/shop/ui/usercommunitywidget',
    'testsuite/qunit-fixture!de_epages/shop/ui/usercommunitywidget-test',

    '$ready!'
], function (QUnit, $, ep, de_epages, fixture) {
    'use strict';

    QUnit.module("de_epages/shop/ui/usercommunitywidget", {
        setup: function () {
            fixture.init();
        },

        teardown: function () {
            fixture.destroy();
        }
    });

    QUnit.asyncTest("de_epages/shop/ui/usercommunitywidget", function () {

        var xmlString = $('#rssData').html(),
            parser = new DOMParser(),
            xmlResponse = parser.parseFromString(xmlString, "text/xml"),
            entryLength;

        /* START - fake ajax request */
        var ajax = ep.ajax;

        ep.ajax = function (o) {
            var result = $.Deferred();

            if (o.dataType) {
                if (o.dataType === "xml") {
                    result.resolve(xmlResponse);
                } else if (o.dataType === "json") {
                    result.resolve(o.data.DereferURLs.split(','));
                }
            } else {
                result.reject();
            }

            return result;
        };
        /* END - fake ajax request */

        $('.ep-UserBlogWidget').shopUiUserCommunityWidget({
            'url': 'http://blog.epages.com/de/feed/'
        });

        setTimeout(function(){
            QUnit.equal(
                $('.ep-shopUiUserCommunityWidget-item').length,
                3,
                'check entry count'
            );

            entryLength = de_epages('.ep-UserBlogWidget').shopUiUserCommunityWidget('option', 'entryLength');
            $('.ep-shopUiUserCommunityWidget-itemTitle').each(function () {
                QUnit.ok(this.innerHTML.length <= entryLength, "check entryLength");
            });
            QUnit.start();
        },200);
    });
});