define("de_epages/molliepayments/ui/checkoutconfirmationhelper", [
    "jquery",
    "ep/ajax",
    "ep/fn/busy",
    "$ready!"
], function ($) {
    return function( BasketForm, BuyButton, IsMobile, options ) {

        var IsDebugEnv = 0;

        function validateBasketFormRequiredCheckBoxes() {
            BasketForm.trigger("validate");
            return ( BasketForm.find('.ui-invalid').length === 0 );

            var CheckBoxValidation = true;
            var TermsAndConditionsCheckBox = ep("form#BasketOfferForm input#AcceptTAC");
            if (TermsAndConditionsCheckBox.length) {
                if (TermsAndConditionsCheckBox.prop("checked")) {
                    TermsAndConditionsCheckBox.parent("div").removeClass("DialogError");
                } else {
                    TermsAndConditionsCheckBox.parent("div").addClass("DialogError");
                    CheckBoxValidation = false;
                }
            }

            var AcceptCustomerInformation = ep("form#BasketOfferForm input#AcceptCustomerInformation");
            if (AcceptCustomerInformation.length) {
                if (AcceptCustomerInformation.prop("checked")) {
                    AcceptCustomerInformation.parent("div").removeClass("DialogError");
                } else {
                    AcceptCustomerInformation.parent("div").addClass("DialogError");
                    CheckBoxValidation = false;
                }
            }
            return CheckBoxValidation;
        }

        function getUrlParameterValue(parameterName) {
            return (typeof options[parameterName] !== 'undefined') ? options[parameterName] : null;
        }

        function recoverMarkedCheckboxes() {
            if (ep('#AcceptTAC').length) {
                ep('#AcceptTAC').prop("checked", true);
            }
            if (ep('#AcceptCustomerInformation').length) {
                ep('#AcceptCustomerInformation').prop("checked", true);
            }

            if (getUrlParameterValue("IsRatingInvitationAllowed")) {
                ep('#IsRatingInvitationAllowed').prop("checked", true);
            }
        }

        function doRequest(requestData, method, callbackSuccess, callbackError) {
            ep.ajax({
                "data": requestData,
                "type": method,
                "dataType": "json"
            }).done(function (response) {
                callbackSuccess(response);
            }).fail(function( response ) {
                callbackError();
            });
        }

        function addBuyButtonClickEvent(callback) {
            BuyButton.on('click.submitMolliePaymentsPurchase', function(event) {
                event.stopPropagation();
                event.preventDefault();
                callback();
                return false;
            });
        }

        function appendErrorAndSubmitBasketForm(caller, debug) {
            if (IsDebugEnv) {
                console.log("Error by caller: " + caller);
                console.log(debug);
            }
            return function(error) {
                var errorName = (error && error.Name) ? error.Name : "Unknown";
                var errorReason = (error && error.Reason) ? error.Reason : "UnknownError";

                BasketForm.append("<input type='hidden' value='" + errorName + "' name='ErrorName'>");
                BasketForm.append("<input type='hidden' value='" + errorReason + "' name='ErrorReason'>");
    
                BasketForm.submit();
            };
        }

        return {
            "validateBasketFormRequiredCheckBoxes": validateBasketFormRequiredCheckBoxes,
            "getUrlParameterValue": getUrlParameterValue,
            "recoverMarkedCheckboxes": recoverMarkedCheckboxes,
            "doRequest": doRequest,
            "addBuyButtonClickEvent": addBuyButtonClickEvent,
            "appendErrorAndSubmitBasketForm": appendErrorAndSubmitBasketForm
        };
    };
});
