/*globals define*/

define([
    'testsuite/qunit',
    'jquery',
    'ep/sslswitch',
    'testsuite/qunit-fixture!ep/sslswitch-test',

    '$ready!'
], function (QUnit, $, ep, fixture) {
    'use strict';

    QUnit.module("ep/sslswitch", {
        setup: function () {
            fixture.init();
        },

        teardown: function () {
            fixture.destroy();
        }
    });

    QUnit.asyncTest("ep/sslswitch", function () {

        var inputCount = $('.SSLSwitch :input').length;

        ep.sslSwitch.addHandle(function (event, form) {
            $('<input type="hidden">')
                .attr({
                    'name': 'example',
                    'value': 'test'
                })
                .appendTo(form);
        });

        ep.sslSwitch.submit = function (form) {
            // prevent submit for test case
            inputCount = form.find(':input').length;
        };

        QUnit.equal(
            inputCount,
            2,
            "$('form').find(':input').length"
        );

        $('form').trigger('submit');

        QUnit.equal(
            ep.sslSwitch.handles.length,
            1,
            "ep.sslSwitch.handles.length"
        );

        QUnit.equal(
            inputCount,
            3,
            "$('form').trigger('submit').find(':input').length"
        );

        QUnit.start();
    });

});